\section{Computational Intense Accelerators: GPUs} \label{sec:gpu}

\begin{figure}[t]
    \centering
    \includegraphics[scale=0.85]{Chapters/Background/Figures/cpu_x_gpu.png}
    \caption{CPU vs GPU}
    \label{fig:cpu_x_gpu}
\end{figure}

%The first question that anyone asks is why there is such a large performance gap between many-core GPUs and general-purpose multicore CPUs. 
There is an enormous difference in the design philosophies between CPUs and GPUs, as shown in Figure \ref{fig:cpu_x_gpu}. The design of a CPU is optimized for sequential code performance, it uses a sophisticated control logic to allow many mechanism that optimize general purpose code execution. Some of these mechanisms are branch prediction that reduce pipe stalls, or large cache memories that reduce the instruction and data access latencies of large complex applications.

Neither control logic nor cache memories contribute to the peak calculation speed. The new general-purpose, multicore microprocessors typically have four large processor cores designed to deliver strong sequential code performance. 

In contrast, the many-core paradigm focuses more on the execution throughput of parallel applications, and typically general-purpose processors (especially the GPUs) uses all the logic for calculation elements, in fact the GPU vendors ever looks for ways to maximize the chip area and power budget dedicated to floating-point calculations. Reaching the highest calculation speed peak and optimizing for the execution throughput of massive numbers of threads are the GPUs main goal. This many-core processors do not have efficient branch or caching mechanism like the CPUs, as a result, much more chip area is dedicated to the floating-point calculations. The hundred core in a GPU allows it to have performance, in term of FLoating point Operations Per Second (GFlops), extremely higher that CPUs. % as shown in Figure \ref{fig:cpu_vs_gpu} \cite{galloy2013accelerated}. 

The many-cores began as a large number of much smaller cores, and the number of cores doubles with each generation following Moore's law \cite{schaller1997moore}. 

%\begin{figure}[t]
%    \centering
%    \includegraphics[scale=0.55]{Figures/cpu_vs_gpu.png}
%    \caption{Performance gap between GPUs and CPUs}
%    \label{fig:cpu_vs_gpu}
%\end{figure}

It should be clear now that a GPU is oriented as numeric computing accelerators, in fact it will not perform well on some tasks on which a CPU is designed to perform well \cite{progmass}. 

An application should use both CPUs and GPUs to execute to the best, the sequential parts on the CPU and numerically intensive parts on the GPUs. This is why the CUDA (Compute Unified Device Architecture) programming model \cite{cudaweb} and OpenCL (Open Computing Language) \cite{openclstdhcs} are designed to support joint CPU and GPU execution of an application.

\subsection{GPU Architecture}

\begin{figure}[t]
    \centering
    \includegraphics[width=1\textwidth]{Chapters/Background/Figures/gpu_arch.png}
    \caption{Architecture of a modern GPU (credits NVIDIA)}
    \label{fig:gpu_arch}
\end{figure}

The main modern GPU element is an array of highly threaded computational unit called Streaming Multiprocessors (SMs). Each SM has a number of single computational core called Streaming Processors (SPs) that share control logic and instruction cache. SPs in the same SM can share data with shared memory embed in the SM. SMs communicate among them through global memory. Figure \ref{fig:gpu_arch} shows an overview of a modern GPU.

Each GPU currently comes with a large global memory of graphics double data rate (GDDR) DRAM with a size of many gigabytes. These GDDR DRAMs differ from the system DRAMs on the CPU motherboard in that they are essentially the frame buffer memory that is used for graphics \cite{progmass}. For graphics applications, they hold video images, and texture information for three-dimensional (3D) rendering, but for computing they function as very-high-bandwidth, off-chip memory, though with somewhat more latency than typical system memory.

\subsection{GPU Programming Model}

Hardware without a programming model that supports developers is useless. Many parallel programming languages and models have been proposed in the past several decades and they can be divided in two categories: message passing and shared memory.

For the first category, the most widely used is the Message Passing Interface (MPI) for scalable cluster computing. MPI is a model where computing nodes in a cluster do not share memory \cite{rabenseifner2009hybrid}, all data sharing and interaction must be done through explicit message passing.

For the second category there are many programming model used. The most famous is CUDA, it provides shared memory for parallel execution in the GPU. As for CPU and GPU communication, CUDA currently provides very limited shared memory capability between the CPU and the GPU. Programmers need to manage the data transfer between the CPU and GPU with specific CUDA functions, this is a big problem because programmers need to well know the GPU memory hierarchy that they are using. The most appreciable CUDA feature is to achieve much higher scalability with simple, low-overhead thread management and no cache coherence hardware requirements.

Another shared memory programming model is OpenMP for shared-memory multiprocessor systems \cite{dagum1998openmp}. OpenMP supports shared memory, so it offers the same advantage as CUDA in programming efforts; however, it main problem is that this model can not scale beyond a couple hundred computing nodes due to thread management overheads and cache coherence hardware requirements.

More recently, several major industry players, including Apple, Intel,
AMD/ATI, and NVIDIA, have jointly developed a standardized programming model called OpenCL \cite{stone2010opencl}. Similar to CUDA, the OpenCL programming model defines language extensions and runtime APIs to allow programmers to manage parallelism and data delivery in massively parallel processors. OpenCL is a standardized programming model in that applications developed in OpenCL can run without modification on all processors that support the OpenCL language extensions and API.

\subsection{NVIDIA Architecture}

%\begin{figure}[t]
%    \centering
%    \includegraphics[scale=0.25]{Figures/fermi_architecture1.png}
%    \caption{NVIDIA Fermi Architecture}
%    \label{fig:fermi_arc}
%\end{figure}

GPU computing is not meant to replace CPU computing. Each approach has advantages for certain kinds of software. CPUs are optimized for general purpose applications where most of the work is being done by a limited number of threads, especially where the threads exhibit high data locality, a mix of different operations, and a high percentage of conditional branches. CPUs gives great importance to branch prediction and data caching.

GPU design aims at the other type of problems: applications with multiple threads that are dominated by longer sequences of computational instructions. Hence, the main  distinction between GPUs and CPUs is that the first is computationally intensive oriented and the second is control-flow intensive oriented. So, GPUs and CPUs resolve different types of problems, and one can not be complete without the other.

The state of the art in GPU design is represented by NVIDIA's next-generation CUDA architecture. The performance and scalability are the main proprieties of all NVIDIA GPUs. %In this section we will see an overview on NVIDIA Fermi Architecture, in figure \ref{fig:fermi_arc}. 
Fermi is not the newest NVIDIA architecture, but it is one of the most important, all the next-generation NVIDIA GPUs have a Fermi-like architecture. Fermi's strength relies in the simple partitioning of a computation into fixed sized blocks of threads in the execution configuration.

The Fermi architecture has 512 CUDA cores are organized in 16 Streaming Multiprocessor (SMs) of 32 cores each. The GPU has six 64-bit memory partitions, for a 384-bit memory interface, supporting up to a total of 6 GB of GDDR5 DRAM memory. A host interface connects the GPU to the CPU via PCI-Express. The GigaThread global scheduler distributes thread blocks to SM thread schedulers \cite{fermi_wp}. Each SM is independently responsible for scheduling its internal resources, cores, and other execution units to perform the work of the threads in its assigned thread blocks.

Distributing work to the streaming multiprocessors is the job of the Giga-Thread global scheduler. Based on the number of blocks and number of threads per block defined in the kernel execution configuration, this scheduler allocates one or more blocks to each SM. How many blocks are assigned to each SM depends on how many resident threads and thread blocks a SM can support \cite{faber}. 

Each SM contains a scheduler and dispatcher, a set of core units, registers file and L1 cache, 16 load /store units and 4 Special Function Units. Each SM is divided in four columns: the two SP columns on the right handle 32-bit integer and floating point, the third column handles load/store operations, and the last column handles ``special functions'' including square roots and transcendentals. 

The SM can mix 16 operations from the first column with 16 from the second column or 16 from the load/store column or with four from the SFU column, or any other combinations the program
specifies.  $64$-bit floating point consumes both SP columns. This means an SM can issue up to $32$ single-precision (32-bit) floating point operations or $16$ double-precision ($64$-bit) floating point operations at a time \cite{fermi_wp}. 

\subsection{The Programming Model}

The complexity of the Fermi architecture is managed by a multi-level programming model that allows software developers to focus on algorithm design rather than the details of how to map the algorithm to the hardware, thus improving productivity.

In NVIDIA's CUDA software platform, as well as in the industry-standard OpenCL framework, the computational elements of algorithms are known as kernels \cite{cudaweb}. Once compiled, kernels consist of many threads that execute the same program in parallel. In an image-processing algorithm, for example, one thread may operate on one pixel, while all the threads on a whole image.

Multiple threads are grouped into thread blocks containing up to 1,536 threads. All of the threads in a thread block will run on a single SM, so within the thread block, threads can cooperate and share memory. Thread blocks can coordinate the use of global shared memory among themselves but may execute in any order, concurrently or sequentially. 
Thread blocks are divided into warps of 32 threads. Just like a thread block for the Giga-Thread scheduler, a warp is the basic unit for scheduling work inside a SM. Because each warp is by definition a block of SIMD threads, the scheduler does not need to check for dependencies within the instruction stream \cite{faber}.

Conditionals statements can greatly decrease performance inside an SM. Fermi architecture GPUs utilizes predication to run short conditional code segments efficiently with no branch instruction overhead. Predication removes branches from the code by executing both the if and else parts of a branch in parallel, which avoids the problem of mispredicted branches and warp divergence. The compiler replaces a branch instruction with predicated instructions only if the number of instructions controlled by the branch condition is less than or equal to a certain threshold. If the code in the branches is too long, the nvcc compiler inserts code to perform warp voting to see if all the threads in a warp take the same branch.

%\begin{figure}[t]
%    \centering
%    \includegraphics[scale=1.4]{Figures/cuda_mem.jpg}
%    \caption{Memory Hierarchy}
%    \label{fig:fermi_mem}
%\end{figure}

%\subsection{Memory Hierarchy}
%The host and all the devices maintain their own separate memory spaces. The fastest and most scalable is the shared memory. The Fermi architecture has an on board memory, in Figure \ref{fig:fermi_mem} is indicated as the Global Memory, it is shared from all SMs and it has a memory size of GBytes. In order to reduce memory access latency, Fermi is the first NVIDIA architecture provides for local memory in each SM. These are:
%
%\begin{enumerate}
%
%	\item L1 Cache: each SM has a L1 cache. This memory is not coherent and it do not behave as a classic LRU cache. It is designed for spatial and not temporal reuse.  
%	
%	\item Shared Memory: this memory enables threads within the same thread block to cooperate, facilitates extensive reuse of on-chip data, and greatly reduces off-chip traffic.
%	
%	\item Register: each SM supports 32K 32-bit registers. The maximum number of
%registers that can be used by a CUDA kernel is 63, due to the limited number of bits available for indexing into the register store. The number of available registers varies on a Fermi SM and it depends of the number of threads simultaneously running in a SM. If the SM is running 1,536 threads, then only 21 registers can be used.
%	
%	\item L2 Cache: Fermi GPUs provide a 768 KB unified L2 cache shared to all SMs, its is guaranteed to provides data coherence to all SMs. L2 provides atomic operations to guarantee data coherence through different thread blocks and also among different kernels.
%
%\end{enumerate} 
%
%In the Fermi architecture, each SM has 64 KB of on-chip memory that can be configured as 48 KB of Shared memory with 16 KB of L1 cache or as 16 KB of Shared memory with 48 KB of L1 cache.
%
%The decision to allocate 16K or 48K of the local memory as cache usually depends on two factors: how much shared memory is needed, and how predictable the kernel's accesses to global memory are likely to be.
